> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.jobgorilla.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.jobgorilla.com/_mcp/server.

# Upsert Job

POST https://feed.jobgorilla.com/job
Content-Type: application/json

Publish a new Job or update an existing Job.

Reference: https://docs.jobgorilla.com/api-reference/jobs/manage-job

## Request

### Headers

- `X-JobGorilla-Key` (string, required)

### Body (application/json)

This endpoint expects a JobPosting.

- `id` (string, required) — Unique identifier for this job posting in your system
- `title` (string, required) — Job title or position name
- `description` (string, required) — Detailed job description including responsibilities, requirements, and qualifications
- `applyUrl` (string, required) — URL where candidates can apply for this position
- `contact` (JobContact, required) — Primary contact information for this job posting
- `company` (Company, required) — Company or organization offering this position
- `location` (Location, required) — Primary work location for this position
- `openings` (integer, required) — Number of available positions for this job posting
- `placementType` (enum, required) — Type of employment arrangement
  - Allowed values: `CONTRACT`, `PERMANENT`, `DIRECT_HIRE`, `CONTRACT_TO_HIRE`
- `currency` (enum, required) — Currency for compensation values
  - Allowed values: `USD`, `USD`
- `payType` (enum, required) — Payment frequency for compensation
  - Allowed values: `NONE`, `HOURLY`, `DAILY`, `MONTHLY`, `ANNUALLY`, `WEEKLY`, `BIWEEKLY`
- `openDate` (datetime, required) — Date when this job posting becomes active and visible
- `enableIndeedApply` (boolean, required, default: true) — Enable Indeed Apply integration for this posting
- `enableZipRecruiterApply` (boolean, required, default: true) — Enable ZipRecruiter Apply integration for this posting
- `createDate` (datetime, required) — Timestamp when this job posting was initially created
- `modifyDate` (datetime, required) — Timestamp when this job posting was last modified
- `postingId` (string, optional) — Alternative or external posting identifier (e.g., from ATS or job board)
- `workFromHome` (boolean, optional, default: false) — Indicates if this position allows work from home
- `workRemote` (boolean, optional, default: false) — Indicates if this is a fully remote position
- `workHybrid` (boolean, optional, default: false) — Indicates if this position offers hybrid work arrangements
- `partTime` (boolean, optional, default: false) — Indicates if this is a part-time position
- `maxPay` (double, optional) — Maximum pay rate or salary based on payType
- `minPay` (double, optional) — Minimum pay rate or salary based on payType
- `endDate` (datetime, optional) — Date when this job posting expires and should be removed
- `screenerQuestionsUrl` (string, optional) — URL to pre-screening questions or assessment for applicants

## Response

### 200

Job successfully created or updated

- `jobGorillaGuid` (string, optional) — The JobGorilla GUID created when the job was created.
- `status` (enum, optional) — The status of the request.
  - Allowed values: `OK`, `ERROR`
- `errors` (list of string, optional) — Any errors to help with troubleshooting a problem.

## Errors

### 400 Bad Request Error

Bad request - validation failed

- `jobGorillaGuid` (string, optional) — The JobGorilla GUID created when the job was created.
- `status` (enum, optional) — The status of the request.
  - Allowed values: `OK`, `ERROR`
- `errors` (list of string, optional) — Any errors to help with troubleshooting a problem.

## Types

### JobContact

- `email` (string, required) — The email of the job contact in RFC-5322 format.
- `name` (string, optional) — The name of the job contact.
- `phone` (string, optional) — The phone number of the job contact.

### Company

- `id` (string, required) — Your system's unique ID for the company.
- `name` (string, required) — The legal name of the company.
- `location` (Location, required) — The main location of the company.
- `directEmployer` (boolean, required) — Is this company a direct employer? This setting affects which job boards get the jobs.For Staffing companies, this must be set to `false`.
- `parentCompany` (Company, optional) — If the company is a logically a part of another company, add that parent company.
- `marketingName` (string, optional) — The name of the company to be sent to Job Boards.
- `linkedInCompanyId` (long, optional) — For jobs to be posted on LinkedIn, the company ID on LinkedIn.[This article by LinkedIn](https://www.linkedin.com/help/linkedin/answer/a415420) will help you find your ID. Sending the wrong LinkedIn ID for a company can cause your entire feed to be disabled.

### Location

Physical location or address information

- `stateCode` (string, required) — State or province code (typically 2-letter abbreviation)
- `countryCode` (string, required) — ISO 3166-1 alpha-2 country code
- `address` (string, optional) — Primary street address
- `address2` (string, optional) — Secondary address line (apartment, suite, floor, etc.)
- `municipality` (string, optional) — City or town name
- `postalCode` (string, optional) — Postal or ZIP code

## Examples

**Request**

```json
{
  "id": "JOB-2024-001234",
  "title": "Senior Software Engineer",
  "description": "We are seeking a Senior Software Engineer to join our team to develop scalable web applications and lead technical projects. Candidates should have 5+ years of experience in software development, a BS",
  "applyUrl": "https://company.com/careers/apply/job-123",
  "contact": {
    "email": "hr@techinnovators.com"
  },
  "company": {
    "id": "COMP-78910",
    "name": "Tech Innovators Inc.",
    "location": {
      "stateCode": "CA",
      "countryCode": "US"
    },
    "directEmployer": true
  },
  "location": {
    "stateCode": "CA",
    "countryCode": "US"
  },
  "openings": 3,
  "placementType": "CONTRACT",
  "currency": "USD",
  "payType": "HOURLY",
  "openDate": "2024-01-15T09:00:00Z",
  "enableIndeedApply": true,
  "enableZipRecruiterApply": true
}
```

**Response**

```json
{
  "jobGorillaGuid": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
  "status": "OK",
  "errors": []
}
```

**SDK Code**

```python
import requests

url = "https://feed.jobgorilla.com/job"

payload = {
    "id": "JOB-2024-001234",
    "title": "Senior Software Engineer",
    "description": "We are seeking a Senior Software Engineer to join our team to develop scalable web applications and lead technical projects. Candidates should have 5+ years of experience in software development, a BS",
    "applyUrl": "https://company.com/careers/apply/job-123",
    "contact": { "email": "hr@techinnovators.com" },
    "company": {
        "id": "COMP-78910",
        "name": "Tech Innovators Inc.",
        "location": {
            "stateCode": "CA",
            "countryCode": "US"
        },
        "directEmployer": True
    },
    "location": {
        "stateCode": "CA",
        "countryCode": "US"
    },
    "openings": 3,
    "placementType": "CONTRACT",
    "currency": "USD",
    "payType": "HOURLY",
    "openDate": "2024-01-15T09:00:00Z",
    "enableIndeedApply": True,
    "enableZipRecruiterApply": True
}
headers = {
    "X-JobGorilla-Key": "X-JobGorilla-Key",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://feed.jobgorilla.com/job';
const options = {
  method: 'POST',
  headers: {'X-JobGorilla-Key': 'X-JobGorilla-Key', 'Content-Type': 'application/json'},
  body: '{"id":"JOB-2024-001234","title":"Senior Software Engineer","description":"We are seeking a Senior Software Engineer to join our team to develop scalable web applications and lead technical projects. Candidates should have 5+ years of experience in software development, a BS","applyUrl":"https://company.com/careers/apply/job-123","contact":{"email":"hr@techinnovators.com"},"company":{"id":"COMP-78910","name":"Tech Innovators Inc.","location":{"stateCode":"CA","countryCode":"US"},"directEmployer":true},"location":{"stateCode":"CA","countryCode":"US"},"openings":3,"placementType":"CONTRACT","currency":"USD","payType":"HOURLY","openDate":"2024-01-15T09:00:00Z","enableIndeedApply":true,"enableZipRecruiterApply":true}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://feed.jobgorilla.com/job"

	payload := strings.NewReader("{\n  \"id\": \"JOB-2024-001234\",\n  \"title\": \"Senior Software Engineer\",\n  \"description\": \"We are seeking a Senior Software Engineer to join our team to develop scalable web applications and lead technical projects. Candidates should have 5+ years of experience in software development, a BS\",\n  \"applyUrl\": \"https://company.com/careers/apply/job-123\",\n  \"contact\": {\n    \"email\": \"hr@techinnovators.com\"\n  },\n  \"company\": {\n    \"id\": \"COMP-78910\",\n    \"name\": \"Tech Innovators Inc.\",\n    \"location\": {\n      \"stateCode\": \"CA\",\n      \"countryCode\": \"US\"\n    },\n    \"directEmployer\": true\n  },\n  \"location\": {\n    \"stateCode\": \"CA\",\n    \"countryCode\": \"US\"\n  },\n  \"openings\": 3,\n  \"placementType\": \"CONTRACT\",\n  \"currency\": \"USD\",\n  \"payType\": \"HOURLY\",\n  \"openDate\": \"2024-01-15T09:00:00Z\",\n  \"enableIndeedApply\": true,\n  \"enableZipRecruiterApply\": true\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("X-JobGorilla-Key", "X-JobGorilla-Key")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://feed.jobgorilla.com/job")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["X-JobGorilla-Key"] = 'X-JobGorilla-Key'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"id\": \"JOB-2024-001234\",\n  \"title\": \"Senior Software Engineer\",\n  \"description\": \"We are seeking a Senior Software Engineer to join our team to develop scalable web applications and lead technical projects. Candidates should have 5+ years of experience in software development, a BS\",\n  \"applyUrl\": \"https://company.com/careers/apply/job-123\",\n  \"contact\": {\n    \"email\": \"hr@techinnovators.com\"\n  },\n  \"company\": {\n    \"id\": \"COMP-78910\",\n    \"name\": \"Tech Innovators Inc.\",\n    \"location\": {\n      \"stateCode\": \"CA\",\n      \"countryCode\": \"US\"\n    },\n    \"directEmployer\": true\n  },\n  \"location\": {\n    \"stateCode\": \"CA\",\n    \"countryCode\": \"US\"\n  },\n  \"openings\": 3,\n  \"placementType\": \"CONTRACT\",\n  \"currency\": \"USD\",\n  \"payType\": \"HOURLY\",\n  \"openDate\": \"2024-01-15T09:00:00Z\",\n  \"enableIndeedApply\": true,\n  \"enableZipRecruiterApply\": true\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://feed.jobgorilla.com/job")
  .header("X-JobGorilla-Key", "X-JobGorilla-Key")
  .header("Content-Type", "application/json")
  .body("{\n  \"id\": \"JOB-2024-001234\",\n  \"title\": \"Senior Software Engineer\",\n  \"description\": \"We are seeking a Senior Software Engineer to join our team to develop scalable web applications and lead technical projects. Candidates should have 5+ years of experience in software development, a BS\",\n  \"applyUrl\": \"https://company.com/careers/apply/job-123\",\n  \"contact\": {\n    \"email\": \"hr@techinnovators.com\"\n  },\n  \"company\": {\n    \"id\": \"COMP-78910\",\n    \"name\": \"Tech Innovators Inc.\",\n    \"location\": {\n      \"stateCode\": \"CA\",\n      \"countryCode\": \"US\"\n    },\n    \"directEmployer\": true\n  },\n  \"location\": {\n    \"stateCode\": \"CA\",\n    \"countryCode\": \"US\"\n  },\n  \"openings\": 3,\n  \"placementType\": \"CONTRACT\",\n  \"currency\": \"USD\",\n  \"payType\": \"HOURLY\",\n  \"openDate\": \"2024-01-15T09:00:00Z\",\n  \"enableIndeedApply\": true,\n  \"enableZipRecruiterApply\": true\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://feed.jobgorilla.com/job', [
  'body' => '{
  "id": "JOB-2024-001234",
  "title": "Senior Software Engineer",
  "description": "We are seeking a Senior Software Engineer to join our team to develop scalable web applications and lead technical projects. Candidates should have 5+ years of experience in software development, a BS",
  "applyUrl": "https://company.com/careers/apply/job-123",
  "contact": {
    "email": "hr@techinnovators.com"
  },
  "company": {
    "id": "COMP-78910",
    "name": "Tech Innovators Inc.",
    "location": {
      "stateCode": "CA",
      "countryCode": "US"
    },
    "directEmployer": true
  },
  "location": {
    "stateCode": "CA",
    "countryCode": "US"
  },
  "openings": 3,
  "placementType": "CONTRACT",
  "currency": "USD",
  "payType": "HOURLY",
  "openDate": "2024-01-15T09:00:00Z",
  "enableIndeedApply": true,
  "enableZipRecruiterApply": true
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'X-JobGorilla-Key' => 'X-JobGorilla-Key',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://feed.jobgorilla.com/job");
var request = new RestRequest(Method.POST);
request.AddHeader("X-JobGorilla-Key", "X-JobGorilla-Key");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"id\": \"JOB-2024-001234\",\n  \"title\": \"Senior Software Engineer\",\n  \"description\": \"We are seeking a Senior Software Engineer to join our team to develop scalable web applications and lead technical projects. Candidates should have 5+ years of experience in software development, a BS\",\n  \"applyUrl\": \"https://company.com/careers/apply/job-123\",\n  \"contact\": {\n    \"email\": \"hr@techinnovators.com\"\n  },\n  \"company\": {\n    \"id\": \"COMP-78910\",\n    \"name\": \"Tech Innovators Inc.\",\n    \"location\": {\n      \"stateCode\": \"CA\",\n      \"countryCode\": \"US\"\n    },\n    \"directEmployer\": true\n  },\n  \"location\": {\n    \"stateCode\": \"CA\",\n    \"countryCode\": \"US\"\n  },\n  \"openings\": 3,\n  \"placementType\": \"CONTRACT\",\n  \"currency\": \"USD\",\n  \"payType\": \"HOURLY\",\n  \"openDate\": \"2024-01-15T09:00:00Z\",\n  \"enableIndeedApply\": true,\n  \"enableZipRecruiterApply\": true\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "X-JobGorilla-Key": "X-JobGorilla-Key",
  "Content-Type": "application/json"
]
let parameters = [
  "id": "JOB-2024-001234",
  "title": "Senior Software Engineer",
  "description": "We are seeking a Senior Software Engineer to join our team to develop scalable web applications and lead technical projects. Candidates should have 5+ years of experience in software development, a BS",
  "applyUrl": "https://company.com/careers/apply/job-123",
  "contact": ["email": "hr@techinnovators.com"],
  "company": [
    "id": "COMP-78910",
    "name": "Tech Innovators Inc.",
    "location": [
      "stateCode": "CA",
      "countryCode": "US"
    ],
    "directEmployer": true
  ],
  "location": [
    "stateCode": "CA",
    "countryCode": "US"
  ],
  "openings": 3,
  "placementType": "CONTRACT",
  "currency": "USD",
  "payType": "HOURLY",
  "openDate": "2024-01-15T09:00:00Z",
  "enableIndeedApply": true,
  "enableZipRecruiterApply": true
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://feed.jobgorilla.com/job")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```